#include "stdafx.h"

using namespace Win;

LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);
LRESULT CALLBACK CustomDlg(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam);

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;

	INT_PTR size;
	static Win::CWndCtrl Control(hWnd);

	LONG h_InstL = GetWindowLong(hWnd, GWL_HINSTANCE);
	HINSTANCE hInst = reinterpret_cast<HINSTANCE>(h_InstL);

	switch (message)
	{
	case WM_CREATE:
		Control.OnCreate();
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
			break;

		case ID_BRUSHSIZE_THIN:
			Control.UpdatePen(1);
			break;

		case ID_BRUSHSIZE_THICK:
			Control.UpdatePen(10);
			break;

		case ID_BRUSHSIZE_CUSTOM:
			size = DialogBox(hInst, (LPCTSTR)IDD_PROPPAGE_SMALL, hWnd, (DLGPROC)CustomDlg);
			Control.UpdatePen(static_cast<int>(size));
			break;

		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;

		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_LBUTTONDOWN:
		Control.OnLButtonDown(lParam);
		break;
	case WM_MOUSEMOVE:
		Control.OnMouseMove(lParam);
		break;
	case WM_LBUTTONUP:
		Control.OnLButtonUp();
		break;
	case WM_PAINT:
		Control.OnPaint();
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}
