#include "stdafx.h"

using namespace Win;

VOID CALLBACK TimerProc(HWND, UINT, UINT, DWORD);

void CWndCtrl::OnCreate()
{
	CDtClock dtClock;
	SetTimer(m_hWnd, ID_TIMER, dtClock.GetInterval(), TimerProc) ;
}

void CWndCtrl::OnLButtonDown(const LPARAM lParam) 
{
	POINTS pt = MAKEPOINTS(lParam);
	RECT rect;
	GetClientRect(m_hWnd, &rect);
	if (pt.y >= rect.bottom - 50 && pt.y < rect.bottom - 10 &&
			pt.x >= rect.left + 10 && pt.x < rect.left + 110) 
		{
			m_ClrRef = GetColor(pt);
			UpdatePen(m_ClrRef);
		}
	else
	{
		m_pressed = true;
		SetCapture(m_hWnd);
		m_lnDraw.SetBegin(lParam);
		m_lnDraw.SetEnd();
		m_lnDraw.DrawLine(m_hWnd);
	}
}

void CWndCtrl::OnMouseMove(const LPARAM lParam)
{
	DrawMousePos(lParam);		
	if (m_pressed)
	{
		m_lnDraw.SetEnd();
		m_lnDraw.SetBegin(lParam);
		m_lnDraw.DrawLine(m_hWnd);
	}
}

void CWndCtrl::OnLButtonUp()
{
	m_pressed = false;
	ReleaseCapture();
}

void CWndCtrl::OnPaint()
{
	PAINTSTRUCT ps;
	HDC hdc = BeginPaint(m_hWnd, &ps);
	EndPaint(m_hWnd, &ps);
}

void CWndCtrl::UpdatePen(COLORREF ClrRef)
{
	m_ClrRef = ClrRef;
	HPEN hPen = CreatePen(PS_SOLID, m_size, m_ClrRef);
	m_lnDraw.UpdatePen(hPen);
}

void CWndCtrl::UpdatePen(int Size)
{
	m_size = Size;
	HPEN hPen = CreatePen(PS_SOLID, m_size, m_ClrRef);
	m_lnDraw.UpdatePen(hPen);
}

void CWndCtrl::DrawMousePos(LPARAM lParam)
{
	POINTS point = MAKEPOINTS(lParam);
	char krd[30];
	HBRUSH hBrush = CreateSolidBrush(RGB(0, 0, 0));
	RECT rect;

	HDC hdc = GetDC(m_hWnd);

	GetClientRect(m_hWnd, &rect);
	sprintf(krd, "x : %d  |  y : %d", point.x, point.y);
	int len = static_cast<int>(strlen(krd));

	SelectObject(hdc, hBrush);
	Rectangle(hdc, 0, 17, 110, 0);
	SetBkColor(hdc, BLACK_BRUSH);
	SetTextColor(hdc, RGB(255, 255, 255));
	DrawText(hdc, krd, len, &rect, 0);
	DeleteObject(hBrush);
	ReleaseDC(m_hWnd, hdc);
}

COLORREF CWndCtrl::GetColor(POINTS pt) const
{
	RECT rc;
	GetClientRect(m_hWnd, &rc);
	COLORREF ClrRef = RGB(0, 0, 0);

	if (pt.y >= rc.bottom - 50 && pt.y < rc.bottom - 30)
	{
		if (pt.x >= rc.left + 30 && pt.x < rc.left + 50)
			ClrRef = RGB(255, 0, 0);
		else if (pt.x >= rc.left + 50 && pt.x < rc.left + 70)
			ClrRef = RGB(255, 255, 0);
		else if (pt.x >= rc.left + 70 && pt.x < rc.left + 90)
			ClrRef = RGB(0, 255, 0);
		else if (pt.x >= rc.left + 90 && pt.x < rc.left + 110)
			ClrRef = RGB(0, 0, 255);
	}
	else if (pt.y >= rc.bottom - 30)
	{
		if (pt.x >= rc.left + 10 && pt.x < rc.left + 30)
			ClrRef = RGB(255, 255, 255);
		else if (pt.x >= rc.left + 30 && pt.x < rc.left + 50)
			ClrRef = RGB(255, 0, 255);
		else if (pt.x >= rc.left + 50 && pt.x < rc.left + 70)
			ClrRef = RGB(255, 150, 0);
		else if (pt.x >= rc.left + 70 && pt.x < rc.left + 90)
			ClrRef = RGB(0, 255, 255);
		else if (pt.x >= rc.left + 90 && pt.x < rc.left + 110)
			ClrRef = RGB(150, 0, 255);
	}
	return ClrRef;
}